<script setup lang="ts">
import { ref, computed } from "vue";
import { storeToRefs } from "pinia";
import { useGallery } from "@/stores/gallery";
import IconsUrl from "@/assets/images/icons.svg";
import BaseButton from "@/components/BaseButton.vue";

defineEmits<{ (e: "finish"): void }>();

const galleryStore = useGallery();
const { upload } = storeToRefs(galleryStore);
const result = computed(() => upload.value?.result);

const showCopyMsg = ref(false);

function handleCopy() {
  return navigator.clipboard.writeText(result.value?.url || "").then(() => {
    showCopyMsg.value = true;
    setTimeout(() => (showCopyMsg.value = false), 3000);
  });
}
</script>

<template>
  <article
    v-if="result"
    class="wrapper"
    role="document"
    id="image-upload-success"
  >
    <svg class="icon">
      <use :href="`${IconsUrl}#check`" tabindex="-1" />
    </svg>

    <h2 class="heading">Uploaded successfully!</h2>
    <img :src="result.url" :alt="result.label" class="image" />
    <p v-if="result.label" class="description">
      {{ result.label }}
    </p>
    <div class="link-section">
      <div class="link-field">
        <p
          class="link"
          aria-label="Link of the uploaded image"
          id="uploaded-image_link"
        >
          {{ result.url }}
        </p>
        <BaseButton
          class="btn btn-copy"
          @click="handleCopy"
          aria-controls="uploaded-image_link"
        >
          Copy link
        </BaseButton>
      </div>
      <p
        class="copy-msg"
        :class="{ 'copy-msg--show': showCopyMsg }"
        aria-live="polite"
      >
        Copied successfully!
      </p>
    </div>
    <BaseButton
      class="btn btn-finish"
      @click="$emit('finish')"
      aria-controls="image-upload-success"
    >
      Finish
    </BaseButton>
  </article>
</template>

<style lang="scss" scoped>
.wrapper {
  padding: 4rem 3.2rem 3.2rem;
  display: grid;
  justify-items: center;
  font-weight: 500;
  line-height: 1.5;
  color: var(--color-grey-dark);
  letter-spacing: -0.035em;
}

.icon {
  fill: var(--color-success);
  width: 4.2rem;
  height: 4.2rem;
  margin-bottom: 0.8rem;
}

.heading {
  margin-bottom: 2.4rem;
  text-transform: capitalize;
}

.image {
  width: 100%;
  object-fit: cover;
  object-position: center;
  margin-bottom: 2.4rem;
  background-color: var(--color-grey-light);
  border-radius: 0.8rem;
}

.description {
  justify-self: start;
  font-size: 1.2rem;
  margin-bottom: 2.4rem;
}

.link-section {
  display: grid;
  margin-bottom: 0.6rem;
}

.link-field {
  width: 100%;
  padding: 0.2rem 0.2rem 0.2rem 1.5rem;
  background-color: var(--color-primary-background-light);
  display: grid;
  grid-template-columns: 1fr 7.6rem;
  grid-template-rows: 4rem;
  column-gap: 1.5rem;
  font-size: 1.4rem;
  align-items: center;
  border-radius: 0.8rem;
  margin-bottom: 1rem;
}

.link {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
}

.btn-copy {
  border-radius: 0.8rem;
  font-size: 1.4rem;
  width: 100%;
  height: 100%;
  text-transform: capitalize;
}

.copy-msg {
  font-size: 1.5rem;
  justify-self: end;
  visibility: hidden;
  opacity: 0;
  transition: opacity var(--transition-config);

  &--show {
    visibility: unset;
    opacity: 1;
  }
}

.btn-finish {
  height: 5rem;
  width: 10rem;
  background-color: var(--color-success);
  box-shadow: var(--box-shadow-size) var(--color-success-shadow-light);
}
</style>
